<?php
	/* 
		Simple PHP file that loads the SQL data into the front-end.
		You can also copy the html (once the normal site is loaded).
		and use that statically if you don't want to use a database.
	*/

	error_reporting(E_ALL);
	ini_set('display_errors', 'on');
	session_start();

	/* Open Mysql Connection */
	$mysql_obj = OpenCon();

	$method = $_POST['method'];
	$all_settings = json_decode($_POST['settings'], true);
	$all_settings_obj = array();

	/* Settings */
	foreach($all_settings as $key => $single_setting){
		$all_settings_obj[$key] = $single_setting;
	}

	/* BEGIN FUNCTIONS */
	try {
		if ($method == "test_backend"){
			$used_response = [];
			$status = "success";

			array_push($used_response, "test");

		    $response = array("status"=>$status, "data"=>$used_response);
		}
		else if($method == "get_functions"){
			$used_response = [];
			$status = "success";

			$get_rows = "
				SELECT
				f.*,
				e.name as endpoint_name,
				se.name as sub_endpoint_name
				FROM `functions` as f
				left join endpoints as e on f.endpointID = e.id
				left join sub_endpoint as se on f.sub_endpointID = se.id
				order by f.id asc;
			";
			$result_q = DoQuery($mysql_obj, $get_rows);

			$all_functions = [];
			while($row = $result_q->fetch_assoc()) {
			    array_push($all_functions, $row);
			}

			$used_response['functions'] = $all_functions;

			$response = array("status"=>$status, "data"=>$used_response);
		}
	} catch (Error $e) {
	    $response = array("status"=>'error', "data"=>$e->getMessage());
	}
	/* END FUNCTIONS */

	/* Close Connection */
	CloseCon($mysql_obj);

	/* echo response in json format */
	echo json_encode($response);

	/* FUNCTIONS */
	function OpenCon()
	{
		$dbhost = "localhost";
		$dbuser = "";
		$dbpass = "";
		$db = "";
		$conn = new mysqli($dbhost, $dbuser, $dbpass,$db) or die("Connect failed: %s\n". $conn -> error);

		return $conn;
	}

	/* Close connection */
	function CloseCon($conn)
	{
		$conn -> close();
	}

	/* Execute query */
	function DoQuery($conn, $query){
		return $conn->query($query);
	}
?>