/* JS File */
var client = null;
var socket = null;
var key_pair = null;
var address = "";
var load_cache = true;

$(document).ready(function(){
	call_backend("get_functions", null);

	$("[name='address_input']").val("");

	/* collapse and expand panel */
	$(".panel_header").unbind("click");
	$(".panel_header").click(function(){
		$(this).stop();
		var used_header = $(this);
		if(used_header.hasClass("collapsed")){
			used_header.removeClass("collapsed");
			used_header.closest(".sub_panel").find(".panel_body").slideDown(100);
		}
		else{
			used_header.addClass("collapsed");
			used_header.closest(".sub_panel").find(".panel_body").slideUp(100);
		}
	});

	/* collapse and expand sub panel */
	$(".divider_sub").click(function(){
		$(this).stop();
		var used_header = $(this);
		if(used_header.hasClass("collapsed")){
			used_header.removeClass("collapsed");
			$(".function_group[used_target='" + used_header.attr("parent_target") + "']").slideDown(100);
		}
		else{
			used_header.addClass("collapsed");
			$(".function_group[used_target='" + used_header.attr("parent_target") + "']").slideUp(100);
		}
	});

	/* confige node btn call */
	$("[name='configure_node']").unbind("click");
	$("[name='configure_node']").click(function(){
		var used_node_type = $("[name='node_type']").val();
		var used_node = $("[name='node']").val();
		var used_port = $("[name='port']").val();
		if(used_node != "" && used_port != ""){
			connect_node(used_node + ':' + used_port, used_node_type);
		}
		else{
			add_output_message('system', 'Give a correct IP and port!', 'error');
		}
	});

	/* create a wallet with a given password */
	$("[name='create_wallet_btn']").unbind("click");
	$("[name='create_wallet_btn']").click(function(){
		var used_password = $("[name='new_pass_input']").val();
		/*const newEntropy = new Buffer.from(crypto.randomBytes(32), 'utf8');
        const newKp = znn.wallet.KeyPair.FromEntropy(newEntropy);
        var download_json = JSON.stringify(await znn.wallet.KeyFile.Encrypt(newEntropy, used_password));
        response_obj = await znn.m_getFrontierAccountBlock(client, key_pair);*/
        if(used_password != ""){
        	wallet_test(used_password);
        }
        else{
        	add_output_message('system', 'Give a password!', 'error');
        }
	});

	/* offline method making a key-pair from a syrius back-up file */
	$("[name='import_wallet_btn']").unbind("click");
	$("[name='import_wallet_btn']").click(function(){
		if(client == null){
			add_output_message('system', 'first configure a node!', 'error');
            return false;
		}

		var files = $("[name='wallet_file_input']").prop("files");
        if (files.length <= 0) {
        	add_output_message('system', 'upload a syrius back-up file!', 'error');
            return false;
        }

        add_output_message('user', 'Started import wallet function', 'success');

        var fr = new FileReader();
        fr.onload = async function (e) {
        	var password = $("[name='pass_input']").val();
        	localStorage.setItem("used_key_data", e.target.result);
        	localStorage.setItem("pass_input", password);
            var result = JSON.parse(e.target.result);
            if(password != ""){
            	await load_file_data(result, password);
            }
            else{
            	add_output_message('system', 'No password given!', 'error');
            }
        }
        fr.readAsText(files.item(0));
	});

	/* Unload the wallet and cache setting */
	$("[name='unload_wallet_btn']").unbind("click");
	$("[name='unload_wallet_btn']").click(function(){
		var used_btn = $(this);
		if(!used_btn.hasClass("disabled")){
			if (localStorage['used_key_data']) {
				localStorage.removeItem("used_key_data");
			}

			key_pair = null;
			set_status("keypair", "offline");
			add_output_message('system', 'Key is correctly unloaded!', 'success');
			$("[name='address_input']").val("");
			used_btn.addClass("disabled");
		}
	});

	/* Unload the wallet and cache setting */
	$("[name='unload_node_btn']").unbind("click");
	$("[name='unload_node_btn']").click(function(){
		var used_btn = $(this);
		if(!used_btn.hasClass("disabled")){
			if (localStorage['used_node_url']) {
				localStorage.removeItem("used_node_url");
			}

			if (localStorage['used_node_type']) {
				localStorage.removeItem("used_node_type");
			}

			client = null;
			set_status("node", "offline");
			add_output_message('system', 'Node is correctly unloaded!', 'success');
			used_btn.addClass("disabled");
		}
	});

	/* send a method btn logic */
	$(".send_button").unbind("click");
	$(".send_button").click(function(){
		var get_checked_method = $(".checkbox_custom.is_checked").closest(".single_function").attr("method_name");
		var get_sub_endpoint_name = $(".checkbox_custom.is_checked").closest(".single_function").attr("sub_endpoint_name");
		
		if(client !== null && key_pair !== null){
			if(get_checked_method !== null && typeof get_checked_method !== "undefined"){
				var data = {};
				var data_valid = true;

				$.each($(".single_param"), function(key, obj){
					var input_obj = $(obj).find("input");
					data[input_obj.attr("clean_name")] = input_obj.val();

					if(input_obj.val() == ""){
						data_valid = false;
						add_output_message('system', 'Parameter cannot be empty!', 'error');
					}
				});

				if(get_sub_endpoint_name == "null"){
					get_sub_endpoint_name = "";
				}

				if(data_valid){
					send_function(get_checked_method, get_sub_endpoint_name, data);
				}
			}
			else{
				add_output_message('system', 'choose a function.', 'error');
			}
		}
		else{
			add_output_message('system', 'Configure a node and wallet.', 'error');
		}
	});

	/* clear output btn */
	$(".clear_output").unbind("click");
	$(".clear_output").click(function(){
		$(".message_wrapper").find(".single_output_message").remove();
	});

	/* show popup */
	$(".help_box").unbind("click");
	$(".help_box").click(function(){
		$(".popup_info").find(".popup_body").find(".popup_dynamic_body").hide();
		show_popup("popup_info");
		$(".popup_info").find(".popup_body").find("." + $(this).attr("used_popup")).show();
	});

	/* Menu */
	$(".menu_btn").unbind("click");
	$(".menu_btn").click(function(){
		if($(".left_menu_hidden").is(":visible")){
			$(".left_menu_hidden").animate({
				left: "-=200",
			},{
				duration: 400,
				easing: "swing",
				complete: function() {
					$(".left_menu_hidden").hide();
				}
			});
			$(".hide_menu_panel").hide();
		}
		else{
			$(".left_menu_hidden").show();
			$(".left_menu_hidden").animate({
				left: "+=200",
			},{
				duration: 400,
				easing: "swing",
				complete: function() {
				}
			});
			$(".hide_menu_panel").show();
		}
	});

	/* hidden panel menu */
	$(".hide_menu_panel").unbind("click");
	$(".hide_menu_panel").click(function(){
		$(".menu_btn").trigger("click");
	});

	/* click of menu item */
	$(".left_menu_hidden").find("li").unbind("click");
	$(".left_menu_hidden").find("li").click(function(){
		$(".menu_btn").trigger("click");
		var clicked_type = $(this).attr("type_link");
		do_menu_action(clicked_type);
	});

	$(".show_password").unbind("click");
	$(".show_password").click(function(){
		if($("[name='new_pass_input']").attr("type") == "password"){
			$("[name='new_pass_input']").attr("type", "text");
		}else{
			$("[name='new_pass_input']").attr("type", "password");
		}
	});

	$(".show_password_1").unbind("click");
	$(".show_password_1").click(function(){
		if($("[name='pass_input']").attr("type") == "password"){
			$("[name='pass_input']").attr("type", "text");
		}else{
			$("[name='pass_input']").attr("type", "password");
		}
	});

	add_output_message('system', '<b>Welcome</b> to the fan-made Zenon Network playground! Here you can import your (test) wallet to see how a node reacts to your requests. <br> Start by connecting to a node with a correct IP and port number (currently using the Alien Valley node)! Then you can import your Syrius <br>wallet back-up file with the correct password. At last you can start by playing with the available functions / methods!', 'success');

	if (location.protocol === 'https:') {
	    show_popup("no_https");
	}

	$(".force_http").unbind("click");
	$(".force_http").click(function(){
		location.replace(`http:${location.href.substring(location.protocol.length)}`);
	});
});

/* do menu action */
function do_menu_action(type){
	if(type == "clear_cache"){
		if(confirm("This will clear the node/wallet cache and reload!")){
			if (localStorage['used_node_url']) {
				localStorage.removeItem("used_node_url");
			}

			if (localStorage['used_node_type']) {
				localStorage.removeItem("used_node_type");
			}

			if (localStorage['used_key_data']) {
				localStorage.removeItem("used_key_data");
			}

			add_output_message('system', 'Cache succesfully cleared, reloading in 2 seconds!', 'success');
			setTimeout(function(){
				location.reload();
			}, 2000);
		}
	}
	else if(type == "links"){
		show_popup("popup_links");
	}
	else if(type == "source"){
		show_popup("popup_source");
	}
	else if(type == "video"){
		show_popup("popup_video");
	}
	else if(type == "donate"){
		show_popup("popup_donate");
	}
}

/* show popup logic */
function show_popup(popup_obj, dynamic_content = ""){
	if($(".popup_panel").is(":visible")){
		close_popup();
	}

	$(".popup_panel").find(".popup_obj").hide();
	$(".popup_panel").find("." + popup_obj).show();	

	if(dynamic_content != ""){
		$(".popup_panel").find("." + popup_obj).find(".popup_body").html(dynamic_content);
	}
	
	$(".popup_panel").show();

	$(".popup_panel").click(function(e){
		if($(e.target).hasClass("popup_panel")){
			close_popup();
		}
	});
}

/* close popup */
function close_popup(){
	$(".popup_panel").hide();
}

/* toggle loading panel (outer panel) */
function toggle_loading(used_text = ""){
	var used_loader = $(".loading_panel");
	if(used_text == ""){
		used_loader.find("span").text("Loading");
	}
	else{
		used_loader.find("span").text(used_text);
	}

	if($(".loading_panel").is(":visible")){
		$(".loading_panel").hide();
	}
	else{
		$(".loading_panel").show();
	}
}

/* retrieve backend data */
function call_backend(method, custom_data){
	var all_settings = {};
	toggle_loading();

	if(custom_data !== null){
		if(Object.keys(custom_data).length > 0){
			all_settings = custom_data;
		}
	}
	
	$.ajax({
	    url : 'backend.php',
	    type : 'POST',
	    data : {
	        'method' : method,
	        'settings' : JSON.stringify(all_settings)
	    },
	    dataType:'json',
	    success : function(data) {
	    	toggle_loading();

	    	after_backend_call(method, data);
	    },
	    error : function(request,error)
	    {
	        alert("Request: " + JSON.stringify(request));
	    },
	    complete : function(){
	    }
	});
}

var all_function_html = {};
function after_backend_call(method, data){
	var data = data['data'];

	/* load cache after functions have been loaded */
	if(method == "get_functions"){
		if(typeof data['functions'] !== "undefined"){
			$.each(data['functions'], function(key, obj){
				var single_function = '';
				single_function += '<div class="single_function noselect" endpoint_name="' + obj['endpoint_name'] + '" sub_endpoint_name="' + obj['sub_endpoint_name'] + '" method_name="' + obj['name'] + '" params="' + obj['params'] + '">';

				if(obj['description'] !== null){
					var used_key = obj['endpoint_name'] + "_" + obj['sub_endpoint_name'] + "_" + obj['name'];
					all_function_html[used_key] = obj['description'];
					single_function += '<div class="help_box" title="' + obj['help_small'] + '" used_popup="dynamic_function"><i class="fa fa-question"></i></div>';
				}

				if(obj['sub_endpoint_name'] !== null){
					single_function += '<div class="function_header"><span>' + obj['sub_endpoint_name'] + '</span></div>';
				}

				single_function += '<div class="checkbox_custom"><i class="fa fa-circle-notch"></i></div>';
				single_function += '<div class="function_name" title="' + obj['name'] + '">' + obj['name'] + '</div>';
				single_function += '</div>';
				$(".function_group[used_target='" + obj['endpoint_name'] + "']").append(single_function);
			});
		}

		/* check a method (deselect others) */
		$(".checkbox_custom").unbind("click");
		$(".checkbox_custom").click(function(){
			var checkbox_obj = $(this);
			var method_name = checkbox_obj.attr("method_name");
			var params = checkbox_obj.closest(".single_function").attr("params");
			uncheck_others(method_name);
			load_params(method_name, params);
			if(checkbox_obj.hasClass("is_checked")){
				checkbox_obj.find("i").removeClass("fa-circle").addClass("fa-circle-notch");
				checkbox_obj.removeClass("is_checked");
			}
			else{
				checkbox_obj.find("i").removeClass("fa-circle-notch").addClass("fa-circle");
				checkbox_obj.addClass("is_checked");
			}
		});

		/* name also trigger check */
		$(".function_name").unbind("click");
		$(".function_name").click(function(){
			$(this).closest(".single_function").find(".checkbox_custom").trigger("click");
		});

		/* show popup */
		$(".single_function").find(".help_box").unbind("click");
		$(".single_function").find(".help_box").click(function(){
			var used_key = $(this).closest(".single_function").attr("endpoint_name") + "_" + $(this).closest(".single_function").attr("sub_endpoint_name") + "_" + $(this).closest(".single_function").attr("method_name");
			var used_text = all_function_html[used_key];
			$(".popup_info").find(".popup_body").find(".popup_dynamic_body").hide();
			show_popup("popup_info");
			$(".popup_info").find(".popup_body").find("." + $(this).attr("used_popup")).html(used_text);
			$(".popup_info").find(".popup_body").find("." + $(this).attr("used_popup")).show();
		});

		/* custom hover animation on help box on single functions */
		var used_hover_obj = null;
		$(".single_function").unbind("hover");
		$(".single_function").hover(function(){
			used_hover_obj = $(this);
			used_hover_obj.find(".help_box").stop(true,true);
			used_hover_obj.find(".help_box").animate({ opacity: 1}, 200);
		}, function(){
			used_hover_obj.find(".help_box").animate({ opacity: 0.5}, 200);
		});

		/* load the cache if a reload is done (or the user comes back another time) can be removed with the unload button */
		if(load_cache){
			if (localStorage['used_node_url'] && localStorage['used_node_type']) {
				connect_node(localStorage['used_node_url'], localStorage['used_node_type']);
			}

			if(localStorage['used_node_type'] == "http"){
				if (localStorage['used_key_data'] && localStorage['pass_input']) {
					key_pair = load_file_data($.parseJSON(localStorage['used_key_data']), localStorage['pass_input']);
					add_output_message('system', 'Using key-pair from cache! You can always define a new one or remove the current one with cache. This can take a couple of seconds.', 'success');
				}
			}
		}
	}
}

/* resize right panel because of animation */
$(window).resize(function() {
	if($(".parameter_list").is(":visible")){
		$(".right_panel").find(".inner_panels").css({"height":"calc(100% - 200px)"});
	}
	else{
		$(".right_panel").find(".inner_panels").css({"height":"calc(100%)"});
	}
});

var is_top = false;
function load_params(method_name, params){
	var all_params = params.split(",");
	$(".all_params").empty();
	if(all_params != ""){
		$.each(all_params, function(key, obj){
			if(obj != ""){
				var default_val = "";

				if(obj == "pageSize"){
					default_val = 5;
				}
				else if(obj == "pageIndex"){
					default_val = 0;
				}

				var single_param = '';
				single_param += '<div class="single_param">';
				single_param += '<label>' + obj + '</label>';
				single_param += '<input type="text" clean_name="' + obj + '" name="param_' + obj + '" value="' + default_val + '"/>';
				single_param += '</div>';
				$(".all_params").append(single_param);
			}
		});

		if(is_top == false){
			$(".parameter_list").stop();
			$(".right_panel").find(".inner_panels").stop();
			$(".right_panel").find(".inner_panels").animate({ height: "-=200"}, 300);
			$(".parameter_list").slideDown(300);
			is_top = true;
		}
	}
	else{
		if(is_top == true){
			$(".parameter_list").slideUp(300);
			$(".right_panel").find(".inner_panels").animate({ height: "+=200"}, 300);
			is_top = false;
		}
	}
}

/* create wallet test */
async function wallet_test(used_password){
	response_obj = await znn.create_wallet(used_password);
	add_output_message('system', 'Wallet created! Output: <br><div class="all_json">' + JSON.stringify(response_obj, null, 2) + '</div>', 'success', true);
	
	$("<a />", {
		"download": "test_wallet.json",
		"href" : "data:application/json," + encodeURIComponent(JSON.stringify(response_obj))
	}).appendTo("body").click(function() {
		$(this).remove()
	})[0].click();
}

/* load keypair */
async function load_file_data(result, password){
	toggle_loading("Loading key-pair");
	set_status("keypair", "waiting");
    let entropy;
    try {
        entropy = await znn.wallet.KeyFile.Decrypt(result, password);
    } catch (e) {
        if (e.toString() === "Error: Unsupported state or unable to authenticate data") {
            add_output_message('system', 'failed to decrypt: invalid password', 'error');
        } else {
            add_output_message('system', 'failed to decrypt' + e.toString(), 'error');
        }
        toggle_loading();
        return;
    }

    key_pair = znn.wallet.KeyPair.FromEntropy(entropy);
    address = key_pair.address.toString();
    add_output_message('system', 'address is: ' + address.toString(), 'success');
    set_status("keypair", "online");
    $("[name='unload_wallet_btn']").removeClass("disabled");
    $("[name='address_input']").val(address.toString());
    set_token_info(address.toString());
	toggle_loading();
}

var coin_info = {};
function set_token_info(address){
	znn.api.ledger.getAccountInfoByAddress(client, address).then((data) => {
		$(".single_coin").remove();

        for (const zts in data.balanceInfoMap) {
            const value = data.balanceInfoMap[zts];

            var used_balance = value.balance / Math.pow(10, value.token.decimals);
            var used_name = value.token.name;
            var single_coin = '';
            single_coin += '<div class="single_coin" used_coin="' + used_name + '">';
            single_coin += '<div class="single_coin_balance">' + used_balance + '</div>';
            single_coin += '<div class="single_coin_name">' + used_name + '</div>';
            single_coin += '<div class="help_box" title="See detailed coin info" used_popup="dynamic_coin"><i class="fa fa-question"></i></div>';
            single_coin += '<div style="clear:both;"></div>';
            single_coin += '</div>';
            coin_info[used_name] = value;

            $(".coin_list").append(single_coin);
        }

		$(".single_coin").find(".help_box").unbind("click");
		$(".single_coin").find(".help_box").click(function(){
			var used_text = syntaxHighlight(coin_info[$(this).closest(".single_coin").attr("used_coin")]);
			$(".popup_info").find(".popup_body").find(".popup_dynamic_body").hide();
			show_popup("popup_info");
			$(".popup_info").find(".popup_body").find("." + $(this).attr("used_popup")).html(used_text);
			$(".popup_info").find(".popup_body").find("." + $(this).attr("used_popup")).show();
		});
    });
}

/* deselect checkbox logic */
function uncheck_others(method_name){
	var all_other = $(".single_function[method_name!='" + method_name + "']").find(".checkbox_custom.is_checked");
	$.each(all_other, function(key, obj){
		$(obj).find("i").removeClass("fa-circle").addClass("fa-circle-notch");
		$(obj).removeClass("is_checked");
	});
}

/* async send function to the znn in the build folder */
async function send_function(method, sub_endpoint_name, data){
	var response_text = '';
	try {
		if(sub_endpoint_name == ""){
			sub_endpoint_name = "default";
		}

		method_switch = method + "_" + sub_endpoint_name;
		switch(method_switch){
			/* EMBEDDED - PILLAR */
			case 'getQsrRegistrationCost_pillar':
					response_obj = await znn.api.embedded.pillar.getQsrRegistrationCost(client);
					response_text = JSON.stringify(response_obj);
				break;
			case 'checkNameAvailability_pillar':
					response_obj = await znn.api.embedded.pillar.checkNameAvailability(client, data['name']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getAll_pillar':
					response_obj = await znn.api.embedded.pillar.getAll(client, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getByOwner_pillar':
					response_obj = await znn.api.embedded.pillar.getByOwner(client, data['ownerAddress']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getByName_pillar':
					response_obj = await znn.api.embedded.pillar.getByName(client, data['name']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getDelegatedPillar_pillar':
					response_obj = await znn.api.embedded.pillar.getDelegatedPillar(client, data['ownerAddress']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getDepositedQsr_pillar':
					response_obj = await znn.api.embedded.pillar.getDepositedQsr(client, data['ownerAddress']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getUncollectedReward_pillar':
					response_obj = await znn.api.embedded.pillar.getUncollectedReward(client, data['ownerAddress']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getFrontierRewardByPage_pillar':
					response_obj = await znn.api.embedded.pillar.getFrontierRewardByPage(client, data['ownerAddress'], parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			/* EMBEDDED - PLASMA */
			case 'get_plasma':
					response_obj = await znn.api.embedded.plasma.get(client, key_pair.address);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getEntriesByAddress_plasma':
					response_obj = await znn.api.embedded.plasma.getEntriesByAddress(client, key_pair.address, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getRequiredPoWForAccountBlock_plasma':
					response_obj = await znn.api.embedded.plasma.getRequiredPoWForAccountBlock(client, key_pair.address, data['blockType'], data['toAddress'], data['data']);
					response_text = JSON.stringify(response_obj);
				break;
			/* EMBEDDED - SENTINEL */
			case 'getByOwner_sentinel':
					response_obj = await znn.api.embedded.sentinel.getByOwner(client, data['ownerAddress']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getAllActive_sentinel':
					response_obj = await znn.api.embedded.sentinel.getAllActive(client, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getDepositedQsr_sentinel':
					response_obj = await znn.api.embedded.sentinel.getDepositedQsr(client, data['ownerAddress']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getUncollectedReward_sentinel':
					response_obj = await znn.api.embedded.sentinel.getUncollectedReward(client, data['ownerAddress']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getFrontierRewardByPage_sentinel':
					response_obj = await znn.api.embedded.sentinel.getFrontierRewardByPage(client, data['ownerAddress'], parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			/* EMBEDDED - STAKE */
			case 'getEntriesByAddress_stake':
					response_obj = await znn.api.embedded.stake.getEntriesByAddress(client, key_pair.address, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getUncollectedReward_stake':
					response_obj = await znn.api.embedded.stake.getUncollectedReward(client, key_pair.address);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getFrontierRewardByPage_stake':
					response_obj = await znn.api.embedded.stake.getFrontierRewardByPage(client, key_pair.address, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			/* EMBEDDED - SWAP */
			case 'getAssetsByKeyIdHash_swap':
					response_obj = await znn.api.embedded.swap.getAssetsByKeyIdHash(client, data['keyId']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getAssets_swap':
					response_obj = await znn.api.embedded.swap.getAssets(client);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getLegacyPillars_swap':
					response_obj = await znn.api.embedded.swap.getLegacyPillars(client);
					response_text = JSON.stringify(response_obj);
				break;
			/* EMBEDDED - TOKEN */
			case 'getAll_token':
					response_obj = await znn.api.embedded.token.getAll(client, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getByOwner_token':
					response_obj = await znn.api.embedded.token.getByOwner(client, data['ownerAddress'], parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getByZts_token':
					response_obj = await znn.api.embedded.token.getByZts(client, data['zts']);
					response_text = JSON.stringify(response_obj);
				break;
			/* LEDGER */
			case 'getFrontierAccountBlock_default':
					response_obj = await znn.api.ledger.getFrontierAccountBlock(client, key_pair.address);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getUnconfirmedBlocksByAddress_default':
					response_obj = await znn.api.ledger.getUnconfirmedBlocksByAddress(client, key_pair.address, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;	
			case 'getUnreceivedBlocksByAddress_default':
					response_obj = await znn.api.ledger.getUnreceivedBlocksByAddress(client, key_pair.address, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getAccountBlockByHash_default':
					response_obj = await znn.api.ledger.getAccountBlockByHash(client, data['hash']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getAccountBlocksByHeight_default':
					response_obj = await znn.api.ledger.getAccountBlocksByHeight(client, parseInt(data['height']), parseInt(data['count']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getAccountBlocksByPage_default':
					response_obj = await znn.api.ledger.getAccountBlocksByPage(client, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getFrontierMomentum_default':
					response_obj = await znn.api.ledger.getFrontierMomentum(client);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getMomentumBeforeTime_default':
					response_obj = await znn.api.ledger.getMomentumBeforeTime(client, parseInt(data['time']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getMomentumByPage_default':
					response_obj = await znn.api.ledger.getMomentumByPage(client, parseInt(data['pageIndex']), parseInt(data['pageSize']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getMomentumByHash_default':
					response_obj = await znn.api.ledger.getMomentumByHash(client, data['hash']);
					response_text = JSON.stringify(response_obj);
				break;
			case 'getMomentumsByHeight_default':
					response_obj = await znn.api.ledger.getMomentumsByHeight(client, parseInt(data['height']), parseInt(data['count']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getDetailedMomentumsByHeight_default':
					response_obj = await znn.api.ledger.getDetailedMomentumsByHeight(client, parseInt(data['height']), parseInt(data['count']));
					response_text = JSON.stringify(response_obj);
				break;
			case 'getAccountInfoByAddress_default':
					response_obj = await znn.api.ledger.getAccountInfoByAddress(client, key_pair.address);
					response_text = JSON.stringify(response_obj);
				break;
			/* STATS */
			case 'osInfo_default':
					response_obj = await znn.api.stats.osInfo(client);
					response_text = JSON.stringify(response_obj);
				break;
			case 'processInfo_default':
					response_obj = await znn.api.stats.processInfo(client);
					response_text = JSON.stringify(response_obj);
				break;
			case 'networkInfo_default':
					response_obj = await znn.api.stats.networkInfo(client);
					response_text = JSON.stringify(response_obj);
				break;
			/* CUSTOM MADE */
			case 'AutoReceive_default':
					var unreceived_hashes = [];
					znn.api.ledger.getUnreceivedBlocksByAddress(client, address, 0, 10).then(async (data) => {
		                for (let index in data.list) {
		                    const block = data.list[index];
		                    const hash = znn.model.Hash.Parse(block.hash);
		                    unreceived_hashes.push(hash.toString());

		                    try {
						        await znn.Receive(client, key_pair, hash);
						    } catch (e) {
						        add_output_message('system', e.toString(), 'error');
						        break;
						    }
		                }
		            });

		            response_text = JSON.stringify(unreceived_hashes);
				break;
			default:
				add_output_message('system', 'function not found.', 'error');
				break;
		}
	} catch (e) {
	    add_output_message('system', JSON.stringify(e), 'error');
	}

	if(response_text != ""){
		add_output_message('system', 'Function done: ' + method + ' Output: <br><div class="all_json">' + response_text + '</div>', 'success', true);
	}
}

/* output message to the front-end output box */
function add_output_message(type, text, status, do_popup = false){
	var currentdate = new Date();
	var datetime = currentdate.getDate() + "/"
    + (currentdate.getMonth()+1)  + "/" 
    + currentdate.getFullYear() + " "  
    + currentdate.getHours() + ":"  
    + currentdate.getMinutes() + ":" 
    + currentdate.getSeconds();

    var type_name = "system";
	var extra_class = '';
	if(status != ""){
		extra_class += status + ' ';
	}
	var single_message = '';
	single_message += '<div class="single_output_message ' + extra_class + '">';

	if(type == "" || type == "system"){
		single_message += '<div class="icon_wrapper"><i class="fa fa-desktop"></i></div>';
	}
	else if(type == "user"){
		single_message += '<div class="icon_wrapper"><i class="fa fa-user"></i></div>';
		type_name = "user";
	}

	var ignore_popup_class = "";
	if(do_popup == false){
		ignore_popup_class = "ignore_popup"
	}
	
	single_message += '<div class="message">';
	single_message += '<div class="message_txt ' + ignore_popup_class + '">' + text + '</div>';
	single_message += '<div class="message_date">done by ' + type_name + ' on ' + datetime + '</div>';
	single_message += '</div>';
	single_message += '</div>';

	$(".message_wrapper").append(single_message);
	$(".message_wrapper").animate({ scrollTop: $('.message_wrapper').prop("scrollHeight")}, 0);

	$(".message_txt").unbind("click");
	$(".message_txt").click(function(){
		if(!$(this).hasClass("ignore_popup")){
			var outer_html = "";
			if($(this).find(".all_json").length > 0){
				var outer_html = syntaxHighlight(JSON.parse($(this).find(".all_json").text()));
			}
			else{
				outer_html = $(this).html();
			}

			show_popup("popup_message_detail", outer_html);
		}
	});
}

/* set status front-end */
function set_status(status, type){
	$(".single_status[used_status='" + status + "']").find(".status").removeClass("status_offline").removeClass("status_waiting").removeClass("status_online");
	$(".single_status[used_status='" + status + "']").find(".status").addClass("status_" + type);
}

/* connect a node with a given IP and port number. the used url will be saved in the cache for the next run */
function connect_node(used_node_url, used_node_type){
	add_output_message('user', 'Started configure node function (current node = ' + client + ')', 'success');

	used_node_url_parts = used_node_url.split(":");
	$("[name='node']").val(used_node_url_parts[0]);
	$("[name='port']").val(used_node_url_parts[1]);
	$("[name='node_type']").val(used_node_type);

	/* normal http/https ajax POST call used as promise */
	if(used_node_type == "http" || used_node_type == "https"){
		client = async (method, params) => $.ajax({
	        type: 'POST',
	        url: used_node_type + '://' + used_node_url,
	        crossDomain: true,
	        data: JSON.stringify({"jsonrpc": "2.0", "id": 0, "method": method, "params": params}),
	        beforeSend: function (xhr) {
	            xhr.setRequestHeader("Content-Type", "application/json");
	            xhr.setRequestHeader("Accept", "application/json, text/plain, */*");
	        },
	        done: function(e){
	        	console.log(e);
	        },
	        fail: function(e){
	        	console.log(e);
	        }
	    });

		/* set data */
		var pre_message = 'Node client on:' + used_node_url + ' with type:' + used_node_type + '. Client output: <br>';
	    add_output_message('system', pre_message + client, 'success',true);
	    localStorage.setItem("used_node_url", used_node_url);
	    localStorage.setItem("used_node_type", used_node_type);
	    set_status("node", "online");
	}
	/* normal and secure websocket logic. I managed to package it the same as the http client so the back-end works the same for both */
	else if(used_node_type == "ws" || used_node_type == "wss"){
		try {
			var used_websocket_url = used_node_type + '://' + used_node_url;
			socket = new WebSocket(used_websocket_url);

			socket.addEventListener('open', function (event) {
				add_output_message('system', 'Client succesfully connected through websocket url:' + used_websocket_url, 'success');

				/* this is where the magic happens */
				client = async (method, params) => new Promise(function(myResolve, myReject) {
					socket.addEventListener('message', function (event) {
						myResolve($.parseJSON(event.data));
					});
					socket.send(JSON.stringify({"jsonrpc": "2.0", "id": 0, "method": method, "params": params}));
				});

				/* set cache data after correct connection */
				if(load_cache){
					if (localStorage['used_key_data'] && localStorage['pass_input']) {
						key_pair = load_file_data($.parseJSON(localStorage['used_key_data']), localStorage['pass_input']);
						add_output_message('system', 'Using key-pair from cache! You can always define a new one or remove the current one with cache. This can take a couple of seconds.', 'success');
					}
				}

				/* set data */
				var pre_message = 'Node client on:' + used_node_url + ' with type:' + used_node_type + '. Client output: <br>';
			    add_output_message('system', pre_message + client, 'success',true);
			    localStorage.setItem("used_node_url", used_node_url);
			    localStorage.setItem("used_node_type", used_node_type);
			    set_status("node", "online");

			    $("[name='unload_node_btn']").removeClass("disabled");
			});
	    } catch (e) {
	        add_output_message('system', e, 'error');
	    }
	}
}

/* pretty json syntax */
function syntaxHighlight(json) {
    if (typeof json != 'string') {
         json = JSON.stringify(json, undefined, 2);
    }
    json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
    return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
        var cls = 'number';
        if (/^"/.test(match)) {
            if (/:$/.test(match)) {
                cls = 'key';
            } else {
                cls = 'string';
            }
        } else if (/true|false/.test(match)) {
            cls = 'boolean';
        } else if (/null/.test(match)) {
            cls = 'null';
        }
        return '<span class="' + cls + '">' + match + '</span>';
    });
}