-- phpMyAdmin SQL Dump
-- version 5.1.3deb1
-- https://www.phpmyadmin.net/
--
-- Host: localhost:3306
-- Generation Time: Apr 05, 2022 at 06:27 PM
-- Server version: 10.6.7-MariaDB-1:10.6.7+maria~bullseye
-- PHP Version: 7.4.15

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `znnplayground`
--

-- --------------------------------------------------------

--
-- Table structure for table `endpoints`
--

CREATE TABLE `endpoints` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `endpoints`
--

INSERT INTO `endpoints` (`id`, `name`) VALUES
(1, 'embedded'),
(2, 'ledger'),
(3, 'stats'),
(5, 'custom_made');

-- --------------------------------------------------------

--
-- Table structure for table `functions`
--

CREATE TABLE `functions` (
  `id` int(11) NOT NULL,
  `endpointID` int(11) NOT NULL DEFAULT 0,
  `sub_endpointID` int(11) NOT NULL DEFAULT 0,
  `name` varchar(255) NOT NULL DEFAULT '',
  `help_small` varchar(500) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `params` varchar(500) NOT NULL DEFAULT '',
  `order` int(11) NOT NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `functions`
--

INSERT INTO `functions` (`id`, `endpointID`, `sub_endpointID`, `name`, `help_small`, `description`, `params`, `order`) VALUES
(1, 1, 1, 'getQsrRegistrationCost', 'This API call will return the current QSR cost for registering a new Pillar.', '<div class=\"function_name\">embedded.pillar.getQsrRegistrationCost</div>\n<div class=\"function_help\">\n	This API call will return the current QSR cost for registering a new Pillar.\n</div>\n<div class=\"function_request\">{\n	\"jsonrpc\": \"2.0\",\n    \"id\": 2,\n    \"method\": \"embedded.pillar.getQsrRegistrationCost\",\n    \"params\": []\n}</div>\n<div class=\"function_response\">\n</div>', '', 1),
(2, 2, 0, 'getFrontierAccountBlock', 'This API call will return the last account block of the specified address', '<div class=\"function_name\">ledger.getFrontierAccountBlock</div>\n<div class=\"function_help\">\n	This API call will return the last account block of the specified address\n</div>\n<div class=\"function_request\">{\n	\"jsonrpc\": \"2.0\",\n	\"id\": 25,\n	\"method\": \"ledger.getFrontierAccountBlock\",\n	\"params\": [\"z1qzpa55k8328ff0ys7jfakfvhw8k2cwm53f5d5u\"]\n}</div>\n<div class=\"function_response\">\n	<ul dir=\"auto\">\n		<li><code>version</code> of type <code>number</code>: current account block version</li>\n		<li><code>chainIdentifier</code> of type <code>number</code>: network chain identifier</li>\n		<li><code>blockType</code> of type <code>number</code>: type of the block</li>\n		<li><code>hash</code> of type <code>string</code>: current account block hash</li>\n		<li><code>previousHash</code> of type <code>string</code>: hash of the block <code>height - 1</code> on this account-chain, <code>000 ... 00</code> if <code>height == 0</code></li>\n		<li><code>height</code> of type <code>number</code>: height of this account-chain</li>\n		<li><code>momentumAcknowledged</code> of type <code>dictionary</code>: momentum that must exists in order for this transaction to be valid\n			<ul dir=\"auto\">\n				<li><code>hash</code> of type <code>string</code>: hash of the momentum</li>\n				<li><code>height</code> of type <code>number</code>: height of the momentum</li>\n			</ul>\n		</li>\n		<li><code>address</code> of type <code>string</code>: address that published this account block</li>\n		<li><code>toAddress</code> of type <code>string</code>: receiving address</li>\n		<li><code>amount</code> of type <code>number</code>: ZTS amount</li>\n		<li><code>tokenStandard</code> of type <code>string</code>: token standard of the coin / token send in the corresponding send block</li>\n		<li><code>fromBlockHash</code> of type <code>string</code>:</li>\n		<li><code>descendantBlocks</code> of type <code>array</code> of <code>dictionaries</code>: all the account blocks that this block generated for embedded smart contracts, <code>null</code> in this case</li>\n		<li><code>data</code> of type <code>string</code>: <code>null</code> in case of default regular transactions, not <code>null</code> otherwise</li>\n		<li><code>fusedPlasma</code> of type <code>number</code>: plasma used for this account block from fusion</li>\n		<li><code>difficulty</code> of type <code>number</code>: PoW difficulty used to generate PoWPlasma</li>\n		<li><code>nonce</code> of type <code>string</code>: nonce that satisfies difficulty</li>\n		<li><code>basePlasma</code> of type <code>number</code>: min plasma for current account block</li>\n		<li><code>usedPlasma</code> of type <code>number</code>: sum of fusedPlasma and PoWPlasma</li>\n		<li><code>changesHash</code> of type <code>string</code>: hash of the changes that were applied to the NoM after inserting this account-block</li>\n		<li><code>publicKey</code> of type <code>string</code>: public key of the account block owner</li>\n		<li><code>signature</code> of type <code>string</code>: signature of this account block</li>\n		<li><code>token</code> of type <code>dictionary</code>: contains all the information about the ZTS, as defined in <a href=\"#embedded.token\">embedded.token</a></li>\n		<li><code>confirmationDetail</code> of type <code>dictionary</code>: contains details about the momentum which contains this account-block\n			<ul dir=\"auto\">\n				<li><code>numConfirmations</code> of type <code>number</code>: height difference between frontier momentum and confirmation-momentum</li>\n				<li><code>momentumHeight</code> of type <code>number</code>: confirmation-momentum height</li>\n				<li><code>momentumHash</code> of type <code>string</code>: confirmation-momentum hash</li>\n				<li><code>momentumTimestamp</code> of type <code>number</code>: confirmation-momentum timestamp</li>\n			</ul>\n		</li>\n		<li><code>pairedAccountBlock</code> of type <code>dictionary</code>: prefetched account-block. For Receive blocks, points to the send block. For send blocks, points to the receive block if it exists. otherwise is null.</li>\n	</ul>\n</div>', '', 2),
(3, 2, 0, 'getUnconfirmedBlocksByAddress', 'This API call will return a list of all account blocks sent to this address that have not been included into a momentum so far', '<div class=\"function_name\">ledger.getUnconfirmedBlocksByAddress</div>\n<div class=\"function_help\">\n	This API call will return a list of all account blocks sent to this address that have not been included into a momentum so far\n</div>\n<div class=\"function_request\">{\n	\"jsonrpc\": \"2.0\",\n    \"id\": 26,\n    \"method\": \"ledger.getUnconfirmedBlocksByAddress\",\n    \"params\": [\"z1qz3f6svf805tewktk5yf9tn8cdhe2236wdnugk\", 0, 1]\n}</div>\n<div class=\"function_response\">\n	<ul dir=\"auto\">\n		<li><code>list</code> of type <code>array</code>: array containing same information as <a href=\"#embedded.ledger.getFrontierAccountBlock\">embedded.ledger.getFrontierAccountBlock</a></li>\n		<li><code>count</code> of type <code>int</code>: number of unconfirmed account blocks in total</li>\n		<li><code>more</code> of type <code>bool</code>: whether there are more unconfirmed account blocks</li>\n	</ul>\n</div>', 'pageIndex,pageSize', 3),
(4, 2, 0, 'getUnreceivedBlocksByAddress', 'This API call will return a list of all account blocks sent to this address that currently don\'t have a corresponding receive account block', '<div class=\"function_name\">ledger.getUnreceivedBlocksByAddress</div>\n<div class=\"function_help\">\n	This API call will return a list of all account blocks sent to this address that currently don\'t have a corresponding receive account block\n</div>\n<div class=\"function_request\">{\n	\"jsonrpc\": \"2.0\",\n    \"id\": 27,\n    \"method\": \"ledger.getUnreceivedBlocksByAddress\",\n    \"params\": [\"z1qqna5fwl9cfd4h7xyg54qdg3nlxgjhntekdlw4\", 0, 5]\n}</div>\n<div class=\"function_response\">\n	\n</div>', 'pageIndex,pageSize', 4),
(5, 2, 0, 'getAccountBlockByHash', 'This API call will return information about the account block with the specified hash', '<div class=\"function_name\">ledger.getAccountBlockByHash</div> <div class=\"function_help\"> 	This API call will return information about the account block with the specified hash </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 28,     \"method\": \"ledger.getAccountBlockByHash\",     \"params\": [\"e543ecc94dc51f68eda9de0ec8ee94ad00ca4608df7b4d3c34b31511811be965\"] }</div> <div class=\"function_response\"> 	 </div>', 'hash', 5),
(6, 2, 0, 'getAccountBlocksByHeight', 'This API call will return a list of account blocks for the account-chain with the specified address', '<div class=\"function_name\">ledger.getAccountBlocksByHeight</div> <div class=\"function_help\"> 	This API call will return a list of account blocks for the account-chain with the specified address </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 29,     \"method\": \"ledger.getAccountBlocksByHeight\",     \"params\": [\"z1qph8dkja68pg3g6j4spwk9re0kjdkul0amwqnt\", 25, 1] }</div> <div class=\"function_response\"> 	 </div>', 'height,count', 6),
(7, 2, 0, 'getAccountBlocksByPage', 'This API call will return a list of account blocks for the account-chain with the specified address for a specified range of pages.', '<div class=\"function_name\">ledger.getAccountBlocksByPage</div> <div class=\"function_help\"> 	This API call will return a list of account blocks for the account-chain with the specified address for a specified range of pages. </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 30,     \"method\": \"ledger.getAccountBlocksByPage\",     \"params\": [\"z1qph8dkja68pg3g6j4spwk9re0kjdkul0amwqnt\", 0, 1] }</div> <div class=\"function_response\"> 	 </div>', 'pageIndex,pageSize', 7),
(8, 2, 0, 'getFrontierMomentum', 'This API call will return the latest momentum', '<div class=\"function_name\">ledger.getFrontierMomentum</div> <div class=\"function_help\"> 	This API call will return the latest momentum </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 31,     \"method\": \"ledger.getFrontierMomentum\",     \"params\": [] }</div> <div class=\"function_response\"> 	<ul dir=\"auto\"> 		<li><code>version</code> of type <code>number</code>: momentum version</li> 		<li><code>chainIdentifier</code> of type <code>number</code>: network chain identifier</li> 		<li><code>hash</code> of type <code>string</code>: hash of the momentum</li> 		<li><code>previousHash</code> of type <code>string</code>: hash of the <code>height - 1</code> momentum</li> 		<li><code>height</code> of type <code>number</code>: height of the momentum</li> 		<li><code>timestamp</code> of type <code>number</code>: UNIX timestamp of accepted momentum</li> 		<li><code>data</code> of type <code>string</code>: encoded smart contract data</li> 		<li><code>content</code> of type <code>dictionary</code>: contains a list of account blocks that are included in this momentum</li> 		<li><code>changesHash</code> of type <code>string</code>: hash of the changes that were applied to the NoM after inserting this momentum</li> 		<li><code>publicKey</code> of type <code>string</code>: public key of the producer</li> 		<li><code>signature</code> of type <code>string</code>: signature of the momentum</li> 		<li><code>producer</code> of type <code>string</code>: <code>producerAddress</code> of the Pillar that produced this momentum</li> 	</ul> </div>', '', 8),
(9, 2, 0, 'getMomentumBeforeTime', 'This API call will return the momentum for the period before the specified time', '<div class=\"function_name\">ledger.getMomentumBeforeTime</div> <div class=\"function_help\"> 	This API call will return the momentum for the period before the specified time </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 32,     \"method\": \"ledger.getMomentumBeforeTime\",     \"params\": [1833524084] }</div> <div class=\"function_response\"> </div>', 'time', 9),
(10, 2, 0, 'getMomentumByHash', 'This API call will return the momentum with the specified hash', '<div class=\"function_name\">ledger.getMomentumByHash</div> <div class=\"function_help\"> 	This API call will return the momentum with the specified hash </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 34,     \"method\": \"ledger.getMomentumByHash\",     \"params\": [\"cd91bd8c8cfbfb7e2b71eee2995d24a2cdec692d04f432951fe1245101d90e53\"] }</div> <div class=\"function_response\"> </div>', 'hash', 10),
(11, 2, 0, 'getMomentumsByHeight', 'This API call will return a list of momentums from height to height + count', '<div class=\"function_name\">ledger.getMomentumsByHeight</div> <div class=\"function_help\"> 	This API call will return a list of momentums from height to height + count </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 35,     \"method\": \"ledger.getMomentumsByHeight\",     \"params\": [34757, 1] }</div> <div class=\"function_response\"> </div>', 'height,count', 11),
(12, 2, 0, 'getMomentumsByPage', 'This API call will return momentums by page', '<div class=\"function_name\">ledger.getMomentumByPage</div> <div class=\"function_help\"> 	This API call will return momentums by page </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\", 	\"id\": 33, 	\"method\": \"ledger.getMomentumsByPage\", 	\"params\": [0, 2] }</div> <div class=\"function_response\"> 	<ul dir=\"auto\"> 		<li><code>list</code> of type <code>array</code>: array containing same information as <a href=\"#ledger.getFrontierMomentum\">ledger.getFrontierMomentum</a></li> 		<li><code>count</code> of type <code>int</code>: number of momentums in total</li> 	</ul> </div>', 'pageIndex,pageSize', 12),
(13, 2, 0, 'getDetailedMomentumsByHeight', 'This API call will return a list of momentums from height to height + count with information about the account blocks they contain', '<div class=\"function_name\">ledger.getDetailedMomentumsByHeight</div> <div class=\"function_help\"> 	This API call will return a list of momentums from height to height + count with information about the account blocks they contain </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 36,     \"method\": \"ledger.getDetailedMomentumsByHeight\",     \"params\": [2, 1] }</div> <div class=\"function_response\"> 	<ul dir=\"auto\"> 		<li><code>count</code> of type <code>number</code>: the total number of momentums</li> 		<li>an array of entries for the rewards with the following fields: 			<ul dir=\"auto\"> 				<li><code>blocks</code> of type <code>array</code> of dictionaries: contains all the blocks inserted in the momentum</li> 				<li><code>momentum</code> of type <code>dictionary</code>: same information as <a href=\"#ledger.getFrontierMomentum\">ledger.getFrontierMomentum</a></li> 			</ul> 		</li> 	</ul> </div>', 'height,count', 13),
(14, 2, 0, 'getAccountInfoByAddress', 'This API call will return information about the account-chain of the specified address', '<div class=\"function_name\">ledger.getAccountInfoByAddress</div> <div class=\"function_help\"> 	This API call will return information about the account-chain of the specified address </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 37,     \"method\": \"ledger.getAccountInfoByAddress\",     \"params\": [\"z1qz5p95pa8c6wq9pvfkg642gjv4nnaayx6vhm2w\"] }</div> <div class=\"function_response\"> 	<ul dir=\"auto\"> 		<li><code>count</code> of type <code>number</code>: the total number of momentums</li> 		<li>an array of entries for the rewards with the following fields: 			<ul dir=\"auto\"> 				<li><code>blocks</code> of type <code>array</code> of dictionaries: contains all the blocks inserted in the momentum</li> 				<li><code>momentum</code> of type <code>dictionary</code>: same information as <a href=\"#ledger.getFrontierMomentum\">ledger.getFrontierMomentum</a></li> 			</ul> 		</li> 	</ul> </div>', '', 14),
(15, 5, 0, 'AutoReceive', 'Custom function that received unreceived momentums', '<div class=\"function_name\">AutoReceive</div> <div class=\"function_help\">  Custom function that auto receives unreceived momentums </div> <div class=\"function_response\"> var unreceived_hashes = []; znn.api.ledger.getUnreceivedBlocksByAddress(client, address, 0, 10).then(async (data) => {     for (let index in data.list) {         const block = data.list[index];         const hash = znn.model.Hash.Parse(block.hash);         unreceived_hashes.push(hash.toString());          try {             await znn.Receive(client, key_pair, hash);         } catch (e) {             add_output_message(\'system\', e.toString(), \'error\');             break;         }     } }); </div>', '', 0),
(16, 1, 1, 'checkNameAvailability', 'This API call will return information about the availability of a name for a Pillar.', '<div class=\"function_name\">embedded.pillar.checkNameAvailability</div> <div class=\"function_help\"> 	This API call will return information about the availability of a name for a Pillar. </div> <div class=\"function_request\">{ 	\"jsonrpc\": \"2.0\",     \"id\": 9,     \"method\": \"embedded.pillar.checkNameAvailability\",     \"params\": [\"Pillar_123\"] }</div> <div class=\"function_response\">     <ul dir=\"auto\">         <li>a parameter of type <code>bool</code>, which is true if the name is available and false otherwise</li>     </ul> </div>', 'name', 2),
(17, 1, 1, 'getAll', 'This API call will return the list of Pillars in the network with additional information.', '<div class=\"function_name\">embedded.pillar.getAll</div>\n<div class=\"function_help\">\nThis API call will return the list of Pillars in the network with additional information.\n</div>\n<div class=\"function_request\">{\n    \"jsonrpc\": \"2.0\",\n    \"id\": 3,\n    \"method\": \"embedded.pillar.getAll\",\n    \"params\": [0, 5]\n}</div>\n<div class=\"function_response\">\n<ul dir=\"auto\">\n<li>\n<p dir=\"auto\"><code>name</code> of type <code>string</code>: name of the registered Pillar</p>\n</li>\n<li>\n<p dir=\"auto\"><code>rank</code> of type <code>int</code>: index of pillar sorted by weight</p>\n</li>\n<li>\n<p dir=\"auto\"><code>type</code> of type <code>int</code>: type of the registered pillar</p>\n</li>\n<li>\n<p dir=\"auto\"><code>isRevocable</code> of type <code>bool</code>: <code>true</code> if the Pillar can be revoked, <code>false</code> otherwise</p>\n</li>\n<li>\n<p dir=\"auto\"><code>ownerAddress</code> of type <code>string</code>: owner address the registered Pillar</p>\n</li>\n<li>\n<p dir=\"auto\"><code>producerAddress</code> of type <code>string</code>: address used by the Pillar to produce momentums</p>\n</li>\n<li>\n<p dir=\"auto\"><code>withdrawAddress</code> of type <code>string</code>: address used to collect the rewards</p>\n</li>\n<li>\n<p dir=\"auto\"><code>giveMomentumRewardPercentage</code> of type <code>int</code> : percentage of momentum rewards distributed to delegators</p>\n</li>\n<li>\n<p dir=\"auto\"><code>giveDelegateRewardPercentage</code> of type <code>int</code> : percentage of delegation rewards distributed to delegators</p>\n</li>\n<li>\n<p dir=\"auto\"><code>isRevocable</code> of type <code>bool</code> : specifies if the pillar is revocable</p>\n</li>\n<li>\n<p dir=\"auto\"><code>revokeCooldown</code> of type <code>number</code>: seconds remaining until revoke window opens</p>\n</li>\n<li>\n<p dir=\"auto\"><code>revokeTimestamp</code> of type <code>number</code>: UNIX timestamp that indicates when the Pillar was revoked</p>\n</li>\n<li>\n<p dir=\"auto\"><code>currentStats</code> - of type <code>dictionary</code> : block producing information</p>\n<ul dir=\"auto\">\n<li><code>producedMomentums</code> of type <code>number</code>: number of momentums produced during current epoch</li>\n<li><code>expectedMomentums</code> of type <code>number</code>: expected number of momentums to be produced during current epoch</li>\n</ul>\n</li>\n<li>\n<p dir=\"auto\"><code>weight</code> of type <code>number</code>: total amount of ZNN delegated to this Pillar</p>\n</li>\n</ul>\n</div>', 'pageIndex,pageSize', 3),
(18, 1, 1, 'getByOwner', 'This API call will return all the Pillars registered by an address.', '<div class=\"function_name\">embedded.pillar.getByOwner</div> <div class=\"function_help\"> This API call will return all the Pillars registered by an address. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 4,     \"method\": \"embedded.pillar.getByOwner\",     \"params\": [\"z1qqna5fwl9cfd4h7xyg54qdg3nlxgjhntekdlw4\"] }</div> <div class=\"function_response\"> </div>', 'ownerAddress', 4),
(19, 1, 1, 'getByName', 'This API call will return information about the Pillar with the specified name.', '<div class=\"function_name\">embedded.pillar.getByName</div> <div class=\"function_help\"> This API call will return information about the Pillar with the specified name. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 5,     \"method\": \"embedded.pillar.getByName\",     \"params\": [\"VPS_1\"] }</div> <div class=\"function_response\"> </div>', 'name', 5),
(20, 1, 1, 'getDelegatedPillar', 'This API call will return the total number of delegations for a particular Pillar.', '<div class=\"function_name\">embedded.pillar.getDelegatedPillar</div> <div class=\"function_help\"> This API call will return the total number of delegations for a particular Pillar. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 8,     \"method\": \"embedded.pillar.getDelegatedPillar\",     \"params\": [\"z1qqdtl63rkhap72nlaymtkemlchwv0ns9ksfjyn\"] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>name</code> of  type <code>string</code>: name of the Pillar</li> <li><code>status</code> of type <code>number</code>: status of the epoch</li> <li><code>weight</code> of type <code>number</code>: total amount of ZNN delegated to this Pillar</li> </ul> </div>', 'ownerAddress', 6),
(21, 1, 1, 'getDepositedQsr', 'This API call will return the amount of QSR deposited that can be used to create a Pillar.', '<div class=\"function_name\">embedded.pillar.getDepositedQsr</div> <div class=\"function_help\"> This API call will return the amount of QSR deposited that can be used to create a Pillar. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 1,     \"method\": \"embedded.pillar.getDepositedQsr\",     \"params\": [\"z1qqdtl63rkhap72nlaymtkemlchwv0ns9ksfjyn\"] }</div> <div class=\"function_response\"> </div>', 'ownerAddress', 7),
(22, 1, 1, 'getUncollectedReward', 'This API call will return the uncollected reward for the specified pillar.', '<div class=\"function_name\">embedded.pillar.getUncollectedReward</div> <div class=\"function_help\"> This API call will return the uncollected reward for the specified pillar. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 6,     \"method\": \"embedded.pillar.getUncollectedReward\",     \"params\": [\"z1qqdtl63rkhap72nlaymtkemlchwv0ns9ksfjyn\"] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>address</code> of type <code>string</code>: address of the Pillar</li> <li><code>znnAmount</code> of type <code>number</code>: the ZNN amount that has to be collected</li> <li><code>qsrAmount</code> of type <code>number</code>: the QSR amount that has to be collected</li> </ul> </div>', 'ownerAddress', 8),
(23, 1, 1, 'getFrontierRewardByPage', 'This API call will return reward information about the specified pillar for a specified range of pages.', '<div class=\"function_name\">embedded.pillar.getFrontierRewardByPage</div> <div class=\"function_help\"> This API call will return reward information about the specified pillar for a specified range of pages. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 7,     \"method\": \"embedded.pillar.getFrontierRewardByPage\",     \"params\": [\"z1qqdtl63rkhap72nlaymtkemlchwv0ns9ksfjyn\", 0, 5] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>address</code> of type <code>string</code>: address of the Pillar</li> <li><code>znnAmount</code> of type <code>number</code>: the ZNN amount that has to be collected</li> <li><code>qsrAmount</code> of type <code>number</code>: the QSR amount that has to be collected</li> </ul> </div>', 'ownerAddress,pageIndex,pageSize', 9),
(24, 1, 2, 'get', 'This API call will return plasma information about an address.', '<div class=\"function_name\">embedded.plasma.get</div> <div class=\"function_help\"> This API call will return plasma information about an address. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 11,     \"method\": \"embedded.plasma.get\",     \"params\": [\"z1qz5fskcw8q6zndyu2w5eps9cyk3ekn9ecvcngd\"] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>currentPlasma</code> of type <code>number</code>: current amount of plasma</li> <li><code>maxPlasma</code> of type <code>number</code>: current maximum amount of plasma for this address</li> <li><code>qsrAmount</code> of type <code>number</code>: amount of QSR being fused for plasma</li> </ul> </div>', '', 1),
(25, 1, 2, 'getEntriesByAddress', 'This API call will return the list of all plasma fusion entries.', '<div class=\"function_name\">embedded.plasma.getEntriesByAddress</div> <div class=\"function_help\"> This API call will return the list of all plasma fusion entries. </div> <div class=\"function_request\">{     \"jsonrpc\": \"1.0\",     \"id\": 12,     \"method\": \"embedded.plasma.getEntriesByAddress\",     \"params\": [\"z1qz5fskcw8q6zndyu2w5eps9cyk3ekn9ecvcngd\", 0, 10] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>count</code> of type <code>int</code>: total number of entries</li> <li><code>list</code> of type <code>array</code>: list containing all the fusion entries. Each item in the list contains the following fields: <ul dir=\"auto\"> <li><code>qsrAmount</code> of type <code>number</code>: fused QSR amount</li> <li><code>beneficiary</code> of type <code>string</code>: the address that will receive plasma</li> <li><code>expirationHeight</code> of type <code>number</code>: momentum height when the fusion entry will expire</li> <li><code>id</code> of type <code>string</code>: id used to revoke this entry</li> </ul> </li> <li><code>qsrAmount</code> of type <code>number</code>: total fused QSR amount from all entries</li> </ul> </div>', 'pageIndex,pageSize', 2),
(26, 1, 2, 'getRequiredPoWForAccountBlock', 'This API call will return the required PoW for a given block', '<div class=\"function_name\">embedded.plasma.getRequiredPoWForAccountBlock</div> <div class=\"function_help\"> no description </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 13,     \"method\": \"embedded.plasma.getRequiredPoWForAccountBlock\",     \"params\": [         {             \"address\": \"z1qz5fskcw8q6zndyu2w5eps9cyk3ekn9ecvcngd\",             \"blockType\": 1,             \"toAddress\": \"z1qqdtl63rkhap72nlaymtkemlchwv0ns9ksfjyn\",             \"data\": \"\"          }     ] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>requiredPlasma</code> of type <code>int</code>: required plasma to send the account block</li> <li><code>requiredDifficulty</code> of type <code>int</code>: required difficulty for the Proof of Work</li> </ul> </div>', 'blockType,toAddress,data', 3),
(27, 1, 3, 'getByOwner', 'This API call will return all the Sentinels registered by an address.', '<div class=\"function_name\">embedded.sentinel.getByOwner</div> <div class=\"function_help\"> This API call will return all the Sentinels registered by an address. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 4,     \"method\": \"embedded.sentinel.getByOwner\",     \"params\": [\"z1qz5fskcw8q6zndyu2w5eps9cyk3ekn9ecvcngd\"] }</div> <div class=\"function_response\">  </div>', 'ownerAddress', 1),
(28, 1, 3, 'getAllActive', 'This API call will return a list of all registered Sentinels.', '<div class=\"function_name\">embedded.sentinel.getAllActive</div> <div class=\"function_help\"> This API call will return a list of all registered Sentinels. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 15,     \"method\": \"embedded.sentinel.getAllActive\",     \"params\": [0, 100] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>count</code> of type <code>number</code>: the total number of registered Sentinels</li> <li>an array of <code>entries</code> with the following fields: <ul dir=\"auto\"> <li><code>owner</code> of type <code>string</code>: the address that registered the Sentinel</li> <li><code>registrationTimestamp</code> of type <code>number</code>: Sentinel\'s registration UNIX timestamp</li> <li><code>isRevocable</code> of type <code>bool</code>: <code>true</code> if the Sentinel can be revoked, <code>false</code> otherwise</li> <li><code>revokeCooldown</code> of type <code>number</code>: seconds until the revoke window</li> <li><code>active</code> of type <code>bool</code>: <code>true</code> if Sentinel is active, <code>false</code> if revoked</li> </ul> </li> </ul> </div>', 'pageIndex,pageSize', 2),
(29, 1, 3, 'getDepositedQsr', 'This API call will return the amount of QSR the address has deposited in order to create a Sentinel.', '<div class=\"function_name\">embedded.sentinel.getDepositedQsr</div> <div class=\"function_help\"> This API call will return the amount of QSR the address has deposited in order to create a Sentinel. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 14,     \"method\": \"embedded.sentinel.getDepositedQsr\",     \"params\": [\"z1qzpa55k8328ff0ys7jfakfvhw8k2cwm53f5d5u\"] }</div> <div class=\"function_response\">  </div>', 'ownerAddress', 3),
(30, 1, 3, 'getUncollectedReward', 'This API call will return the uncollected reward for the specified sentinel.', '<div class=\"function_name\">embedded.sentinel.getUncollectedReward</div> <div class=\"function_help\"> This API call will return the uncollected reward for the specified sentinel. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 17,     \"method\": \"embedded.sentinel.getUncollectedReward\",     \"params\": [\"z1qzpa55k8328ff0ys7jfakfvhw8k2cwm53f5d5u\"] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>address</code> of type <code>string</code>: address of the Sentinel</li> <li><code>znnAmount</code> of type <code>number</code>: the ZNN amount that has to be collected</li> <li><code>qsrAmount</code> of type <code>number</code>: the QSR amount that has to be collected</li> </ul> </div>', 'ownerAddress', 4),
(31, 1, 3, 'getFrontierRewardByPage', 'This API call will return reward information the specified sentinel for a specified range of pages.', '<ul dir=\"auto\"> <li><code>epoch</code> of type <code>number</code>: the specified epoch</li> <li><code>znnAmount</code> of type <code>number</code>: the ZNN amount that has to be collected</li> <li><code>qsrAmount</code> of type <code>number</code>: the QSR amount that has to be collected</li> </ul>', 'ownerAddress,pageIndex,pageSize', 5),
(32, 1, 4, 'getEntriesByAddress', 'This API call will return staking information for a particular address', '<ul dir=\"auto\"> <li><code>totalAmount</code> of type <code>int</code>: total amount of ZNN staked</li> <li><code>totalWeightedAmount</code> of type <code>int</code>: total weighted amount of ZNN staked</li> <li><code>count</code> of type <code>number</code>: number of entries</li> <li><code>list</code> of type <code>array</code>: list of entries. Each entry is defined by the following fields: <ul dir=\"auto\"> <li><code>amount</code> of type <code>number</code>: staking amount</li> <li><code>weightedAmount</code> of type <code>number</code>: ZNN amount that is actually staked calculated based on the number of months</li> <li><code>startTimestamp</code> of type <code>number</code>: UNIX timestamp of stake registration</li> <li><code>expirationTimestamp</code> of type <code>number</code>: UNIX timestamp of stake expiration</li> <li><code>address</code> of type <code>string</code>: staking address</li> <li><code>id</code> of type <code>string</code>: id of stake, used to cancel the stake</li> </ul> </li> </ul>', 'pageIndex,pageSize', 1),
(33, 1, 4, 'getUncollectedReward', 'This API call will return the uncollected reward(s) for the specified stake.', '<div class=\"function_name\">embedded.stake.getUncollectedReward</div> <div class=\"function_help\"> This API call will return the uncollected reward(s) for the specified stake. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 17,     \"method\": \"embedded.stake.getUncollectedReward\",     \"params\": [\"z1qzpa55k8328ff0ys7jfakfvhw8k2cwm53f5d5u\"] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>address</code> of type <code>string</code>: address of the Stake</li> <li><code>znnAmount</code> of type <code>number</code>: the ZNN amount that has to be collected</li> <li><code>qsrAmount</code> of type <code>number</code>: the QSR amount that has to be collected</li> </ul> </div>', '', 2),
(34, 1, 4, 'getFrontierRewardByPage', 'This API call will return reward information the specified stake for a specified range of pages.', '<ul dir=\"auto\"> <li><code>count</code> of type <code>number</code>: the total number of the epochs</li> <li>an array of entries for the rewards with the following fields: <ul dir=\"auto\"> <li><code>epoch</code> of type <code>number</code>: the specified epoch</li> <li><code>znnAmount</code> of type <code>number</code>: the ZNN amount that has to be collected</li> <li><code>qsrAmount</code> of type <code>number</code>: the QSR amount that has to be collected</li> </ul> </li> </ul>', 'pageIndex,pageSize', 3),
(35, 1, 5, 'getAssetsByKeyIdHash', 'This API call will return the amount of ZNN and QSR that have not been swapped yet', '<div class=\"function_name\">embedded.swap.getAssetsByKeyIdHash</div> <div class=\"function_help\"> This API call will return the amount of ZNN and QSR that have not been swapped yet </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 20,     \"method\": \"embedded.swap.getAssetsByKeyIdHash\",     \"params\": [\"3835082b4afb76971d58d6ad510e7e91f3bb0d41912fac4ec4cfef7bd7bbea73\"] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>sha256</code> sum of the legacy keyId which is <code>HASH160</code> sum of a legacy public key</li> <li><code>qsr</code> of type <code>number</code>: QSR amount left</li> <li><code>znn</code> of type <code>number</code>: ZNN amount left</li> </ul> </div>', 'keyId', 1),
(36, 1, 5, 'getAssets', 'This API call will return for every keyId hash the amount of znn or qsr that can be swapped', '<div class=\"function_name\">embedded.swap.getAssets</div> <div class=\"function_help\"> This API call will return for every keyId hash the amount of znn or qsr that can be swapped </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 20,     \"method\": \"embedded.swap.getAssets\",     \"params\": [] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>keyIdHash</code> of type string: <code>sha256</code> sum of the legacy keyId which is <code>HASH160</code> sum of a legacy public key</li> <li><code>qsr</code> of type <code>number</code>: QSR amount left</li> <li><code>znn</code> of type <code>number</code>: ZNN amount left</li> </ul> </div>', '', 2),
(37, 1, 5, 'getLegacyPillars', 'This API call will return the number of legacy Pillars not swapped yet', '<div class=\"function_name\">embedded.swap.getLegacyPillars</div> <div class=\"function_help\"> This API call will return the number of legacy Pillars not swapped yet </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 21,     \"method\": \"embedded.swap.getLegacyPillars\",     \"params\": [] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>KeyIdHash</code> of type <code>string</code>:  <code>sha256</code> sum of the legacy keyId which is <code>HASH160</code> sum of a legacy public key</li> <li><code>numPillars</code> of type <code>number</code>: number of legacy Pillars left</li> </ul> </div>', '', 3),
(38, 1, 6, 'getAll', 'This API call will return a list of all ZTS tokens', '<div class=\"function_name\">embedded.token.getAll</div> <div class=\"function_help\"> This API call will return a list of all ZTS tokens </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 22,     \"method\": \"embedded.token.getAll\",     \"params\": [0, 2] }</div> <div class=\"function_response\"> <ul dir=\"auto\"> <li><code>count</code> of type <code>number</code>: total number of ZTS tokens</li> <li><code>list</code> of type <code>array</code>: array containing information about each token ordered by creation time. Each entry is defined by the following fields: <ul dir=\"auto\"> <li><code>name</code> of type <code>string</code>: name of the ZTS token</li> <li><code>symbol</code> of type <code>string</code>: symbol of the ZTS token</li> <li><code>domain</code> of type <code>string</code>: that represent a valid web domain</li> <li><code>totalSupply</code> of type <code>number</code>: circulating supply</li> <li><code>decimals</code> of type <code>number</code>: number of decimals</li> <li><code>owner</code> of type <code>string</code>: address that issued this token</li> <li><code>tokenStandard</code> of type <code>string</code>: unique identifier of this ZTS</li> <li><code>maxSupply</code> of type <code>number</code>: maximum supply</li> <li><code>isBurnable</code> of type <code>bool</code>: <code>true</code> if it can be burned by any holder, <code>false</code> if it can be burned only by its owner</li> <li><code>isMintable</code> of type <code>bool</code>: <code>true</code> if the owner can increase the supply by minting, <code>false</code> otherwise</li> <li><code>isUtility</code> of type <code>bool</code>: <code>true</code> if the token is utilty, <code>false</code> otherwise</li> </ul> </li> </ul> </div>', 'pageIndex,pageSize', 1),
(39, 1, 6, 'getByOwner', 'This API call will return the list of ZTS issued by an address', '<div class=\"function_name\">embedded.token.getByOwner</div> <div class=\"function_help\"> This API call will return the list of ZTS issued by an address </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 24,     \"method\": \"embedded.token.getByOwner\",     \"params\": [\"z1qz5p95pa8c6wq9pvfkg642gjv4nnaayx6vhm2w\", 0, 5] }</div> <div class=\"function_response\"> </div>', 'ownerAddress,pageIndex,pageSize', 2),
(40, 1, 6, 'getByZts', 'This API call will return the ZTS with the specified unique indentifier', '<div class=\"function_name\">embedded.token.getByZts</div> <div class=\"function_help\"> This API call will return the ZTS with the specified unique indentifier </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 23,     \"method\": \"embedded.token.getByZts\",     \"params\": [\"zts1nl8h22r2ynw9jyeg5q5ssq\"] }</div> <div class=\"function_response\"> </div>', 'zts', 3),
(42, 3, 0, 'osInfo', 'This API call will return information about the os.', '<div class=\"function_name\">stats.osInfo</div> <div class=\"function_help\"> This API call will return information about the os. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 40,     \"method\": \"stats.osInfo\",     \"params\": [] }</div> <div class=\"function_response\"> </div>', '', 1),
(43, 3, 0, 'processInfo', 'This API call will return information about the process.', '<div class=\"function_name\">stats.processInfo</div> <div class=\"function_help\"> This API call will return information about the process. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 40,     \"method\": \"stats.processInfo\",     \"params\": [] }</div> <div class=\"function_response\"> </div>', '', 2),
(44, 3, 0, 'networkInfo', 'This API call will return information about the network.', '<div class=\"function_name\">stats.networkInfo</div> <div class=\"function_help\"> This API call will return information about the network. </div> <div class=\"function_request\">{     \"jsonrpc\": \"2.0\",     \"id\": 40,     \"method\": \"stats.networkInfo\",     \"params\": [] }</div> <div class=\"function_response\"> </div>', '', 3);

-- --------------------------------------------------------

--
-- Table structure for table `sub_endpoint`
--

CREATE TABLE `sub_endpoint` (
  `id` int(11) NOT NULL,
  `endpointID` int(11) NOT NULL DEFAULT 0,
  `name` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `sub_endpoint`
--

INSERT INTO `sub_endpoint` (`id`, `endpointID`, `name`) VALUES
(1, 1, 'pillar'),
(2, 1, 'plasma'),
(3, 1, 'sentinel'),
(4, 1, 'stake'),
(5, 1, 'swap'),
(6, 1, 'token');

--
-- Indexes for dumped tables
--

--
-- Indexes for table `endpoints`
--
ALTER TABLE `endpoints`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `functions`
--
ALTER TABLE `functions`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sub_endpoint`
--
ALTER TABLE `sub_endpoint`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `endpoints`
--
ALTER TABLE `endpoints`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6;

--
-- AUTO_INCREMENT for table `functions`
--
ALTER TABLE `functions`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=45;

--
-- AUTO_INCREMENT for table `sub_endpoint`
--
ALTER TABLE `sub_endpoint`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
